#----------------------------------------------------------------------------bh-
# This RPM .spec file is part of the OpenHPC project.
#
# It may have been modified from the default version supplied by the underlying
# release package (if available) in order to apply patches, perform customized
# build/install configurations, and supply additional files to support
# desired integration conventions.
#
#----------------------------------------------------------------------------eh-

%include %{_sourcedir}/OHPC_macros

# Base package name
%define ohpc_python_dependent 1 
%define python_family python3
%define pname buildtest

Name:           %{pname}%{PROJ_DELIM}
Version:        0.7.0
Release:        16.1
Url:            https://github.com/HPC-buildtest/buildtest-framework
Summary:        A software stack testing framework that automates test creation
License:        GPLv3
Group:          %{PROJ_NAME}/admin
Source0:        https://github.com/HPC-buildtest/buildtest-framework/archive/v%{version}/buildtest-framework-%{version}.tar.gz
Patch1:         buildtest-versionstring.patch
Requires:       lmod%{PROJ_DELIM} >= 7.6.1
%if 0%{?suse_version}
BuildRequires:  fdupes
#!BuildIgnore: post-build-checks
BuildRequires:  python3-PyYAML
Requires:       python3-argcomplete
%else
BuildRequires:  python36-PyYAML
Requires:       python36-PyYAML
Requires:       python36-argcomplete
%endif
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools

# Default library install path
%define install_path %{OHPC_LIBS}/%{compiler_family}/%{pname}/%version

%description
buildtest is a software stack testing framework that automates test creation and
execution to help HPC facilities to better support and validate their software
stack. buildtest is a central repository with collection of tests for all
scientific software that is installed in HPC. buildtest makes use of YAML
configuration to write test configuration that is reusable and adaptable to
other HPC sites.

%prep
%setup -q -n %{pname}-framework-%{version}
%patch1 -p1

%build
source ./sourceme.sh
python3 setup.py build $COMPILER_FLAG


%install
source ./sourceme.sh
python3 setup.py install --root="%{buildroot}" --prefix="%{install_path}"
%{__cp} settings.yml %{buildroot}%{install_path}/lib/python3.6/site-packages

%if 0%{?suse_version}
%fdupes -s %{buildroot}%{install_path}
%endif

# OpenHPC module file
%{__mkdir_p} %{buildroot}%{OHPC_MODULES}/%{pname}
%{__cat} << EOF > %{buildroot}/%{OHPC_MODULES}/%{pname}/%{version}
#%Module1.0#####################################################################

proc ModulesHelp { } {

puts stderr " "
puts stderr "This module loads the %{pname} utility"
puts stderr "\nVersion %{version}\n"

}
module-whatis "Name: %{pname}"
module-whatis "Version: %{version}"
module-whatis "Category: python module"
module-whatis "Description: %{summary}"
module-whatis "URL %{url}"

set     version             %{version}
setenv          BUILDTEST_ROOT      %{install_path}/lib/python3.6/site-packages

prepend-path    PATH                %{install_path}/bin
prepend-path    PYTHONPATH          %{install_path}/lib/python3.6/site-packages

setenv          %{PNAME}_DIR        %{install_path}
setenv          %{PNAME}_BIN        %{install_path}/bin

EOF

%{__cat} << EOF > %{buildroot}/%{OHPC_MODULES}/%{pname}/.version.%{version}
#%Module1.0#####################################################################
##
## version file for %{pname}-%{version}
##
set     ModulesVersion      "%{version}"
EOF

%{__mkdir_p} ${RPM_BUILD_ROOT}/%{_docdir}

%files
%{OHPC_PUB}
%doc CONTRIBUTING.rst
%doc LICENSE
%doc README.rst
